﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr159_1
{
    // Первый интерфейс: 
    interface First {
        // Свойство: 
        int number { 
            get; 
            set;
        }
        // Индексатор: 
        int this[int k]{ 
            get;
        }
    }

    // Второй интерфейс: 
    interface Second {
        // Методы:
        void setNum(int n);
        int getNum();
    }

    // Интерфейс наследует другие интерфейсы: 
    interface MyInterface: First, Second {
        // Метод: 
        void show();
    }

    // Класс реализует интерфейс: 
    class MyClass: MyInterface { 
        private int num; 
        public MyClass(int n) { 
            number = n; 
            show();
        }
        public void show() {
            Console.WriteLine("Свойство number = " + number);
        }
        public void setNum(int n) { 
            num = n;
        }
        public int getNum() { 
            return num;
        }
        public int number{ 
            get {
                return getNum();
            }
            set {
                setNum(value);
            }
        }
        public int this[int k]{ 
            get {
                int r = number; 
                for(int i = 0; i < k; i++) { 
                    r /= 10;
                }
                return r % 10;
            }
        }
    }

    // Класс с главным методом: 
    class Program
    {
        static void Main()
        {
            int m = 9;
            MyClass obj = new MyClass(12345); 
            for (int i = 0; i <= m; i++)
            {
                Console.Write("|" + obj[m - i]);
            }
            Console.WriteLine("|");
            // Задержка:
            Console.ReadLine();
        }
    }
}
